/*  $Id: outputsource_netstream.cpp,v 1.4 2003/07/20 22:34:40 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "API/Network/NetSession/outputsource_netstream.h"
#include "API/Network/NetSession/netstream.h"
#include "netstream_generic.h"

/////////////////////////////////////////////////////////////////////////////
// CL_OutputSource_NetStream Construction:

CL_OutputSource_NetStream::CL_OutputSource_NetStream(const CL_NetStream &sock)
: netstream(sock.impl), ref_count_netstream(true)
{
	netstream->add_ref();
}

CL_OutputSource_NetStream::~CL_OutputSource_NetStream()
{
	if (ref_count_netstream) netstream->release_ref();
}

/////////////////////////////////////////////////////////////////////////////
// CL_OutputSource_NetStream Attributes:

int CL_OutputSource_NetStream::tell() const
{
	return 0;
}

int CL_OutputSource_NetStream::size() const
{
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CL_OutputSource_NetStream Operations:

int CL_OutputSource_NetStream::write(const void *data, int size)
{
	return CL_NetStream(netstream).send(data, size);
}
	
void CL_OutputSource_NetStream::open()
{
}

void CL_OutputSource_NetStream::close()
{
}

CL_OutputSource *CL_OutputSource_NetStream::clone()
{
	return new CL_OutputSource_NetStream(CL_NetStream(netstream));
}
